--Ktantan
--Keyschedule

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY keyschedule IS
  PORT(
    K : IN STD_LOGIC_VECTOR(79 DOWNTO 0);    --key
    T : IN STD_LOGIC_VECTOR(7 DOWNTO 0);     --round counter ?
    ka : OUT STD_LOGIC;                      --subkey a
    kb : OUT STD_LOGIC                       --subkey b
    );
END keyschedule;

ARCHITECTURE rtl OF keyschedule IS

-------Int. signals declaration------
SIGNAL ind : STD_LOGIC_VECTOR(3 DOWNTO 0); --index
SIGNAL a   : STD_LOGIC_VECTOR(4 DOWNTO 0); 
SIGNAL t1_t0 : STD_LOGIC_VECTOR(1 DOWNTO 0);

BEGIN

    ind(0) <= T(4);
    ind(1) <= T(5);
    ind(2) <= T(6);
    ind(3) <= T(7);

    a(0) <= K(to_integer(unsigned(ind)));
    a(1) <= K(to_integer(unsigned(ind))+16);
    a(2) <= K(to_integer(unsigned(ind))+32);
    a(3) <= K(to_integer(unsigned(ind))+48);
    a(4) <= K(to_integer(unsigned(ind))+64);
    
    t1_t0(0) <= T(0);
    t1_t0(1) <= T(1);

    ka <= ((NOT T(3)) AND (NOT T(2)) AND a(0)) XOR ((T(3) OR T(2)) AND a(to_integer(unsigned(t1_t0))));
    kb <= ((NOT T(3)) AND T(2) AND a(4)) XOR ((T(3) OR (NOT T(2))) AND a(to_integer(unsigned(NOT t1_t0))));

END rtl;
